const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Memoriais_descritivos_asbuiltDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const memoriais_descritivos_asbuilt =
      await db.memoriais_descritivos_asbuilt.create(
        {
          id: data.id || undefined,

          titulo: data.titulo || null,
          descricao: data.descricao || null,
          arquivo_digital: data.arquivo_digital || null,
          data_entrega: data.data_entrega || null,
          responsavel_tecnico: data.responsavel_tecnico || null,
          validado_por_copasa: data.validado_por_copasa || false,

          comentarios_validacao: data.comentarios_validacao || null,
          importHash: data.importHash || null,
          createdById: currentUser.id,
          updatedById: currentUser.id,
        },
        { transaction },
      );

    await memoriais_descritivos_asbuilt.setObra(data.obra || null, {
      transaction,
    });

    await memoriais_descritivos_asbuilt.setClientes(data.clientes || null, {
      transaction,
    });

    return memoriais_descritivos_asbuilt;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const memoriais_descritivos_asbuiltData = data.map((item, index) => ({
      id: item.id || undefined,

      titulo: item.titulo || null,
      descricao: item.descricao || null,
      arquivo_digital: item.arquivo_digital || null,
      data_entrega: item.data_entrega || null,
      responsavel_tecnico: item.responsavel_tecnico || null,
      validado_por_copasa: item.validado_por_copasa || false,

      comentarios_validacao: item.comentarios_validacao || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const memoriais_descritivos_asbuilt =
      await db.memoriais_descritivos_asbuilt.bulkCreate(
        memoriais_descritivos_asbuiltData,
        { transaction },
      );

    // For each item created, replace relation files

    return memoriais_descritivos_asbuilt;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const memoriais_descritivos_asbuilt =
      await db.memoriais_descritivos_asbuilt.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.titulo !== undefined) updatePayload.titulo = data.titulo;

    if (data.descricao !== undefined) updatePayload.descricao = data.descricao;

    if (data.arquivo_digital !== undefined)
      updatePayload.arquivo_digital = data.arquivo_digital;

    if (data.data_entrega !== undefined)
      updatePayload.data_entrega = data.data_entrega;

    if (data.responsavel_tecnico !== undefined)
      updatePayload.responsavel_tecnico = data.responsavel_tecnico;

    if (data.validado_por_copasa !== undefined)
      updatePayload.validado_por_copasa = data.validado_por_copasa;

    if (data.comentarios_validacao !== undefined)
      updatePayload.comentarios_validacao = data.comentarios_validacao;

    updatePayload.updatedById = currentUser.id;

    await memoriais_descritivos_asbuilt.update(updatePayload, { transaction });

    if (data.obra !== undefined) {
      await memoriais_descritivos_asbuilt.setObra(
        data.obra,

        { transaction },
      );
    }

    if (data.clientes !== undefined) {
      await memoriais_descritivos_asbuilt.setClientes(
        data.clientes,

        { transaction },
      );
    }

    return memoriais_descritivos_asbuilt;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const memoriais_descritivos_asbuilt =
      await db.memoriais_descritivos_asbuilt.findAll({
        where: {
          id: {
            [Op.in]: ids,
          },
        },
        transaction,
      });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of memoriais_descritivos_asbuilt) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of memoriais_descritivos_asbuilt) {
        await record.destroy({ transaction });
      }
    });

    return memoriais_descritivos_asbuilt;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const memoriais_descritivos_asbuilt =
      await db.memoriais_descritivos_asbuilt.findByPk(id, options);

    await memoriais_descritivos_asbuilt.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await memoriais_descritivos_asbuilt.destroy({
      transaction,
    });

    return memoriais_descritivos_asbuilt;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const memoriais_descritivos_asbuilt =
      await db.memoriais_descritivos_asbuilt.findOne(
        { where },
        { transaction },
      );

    if (!memoriais_descritivos_asbuilt) {
      return memoriais_descritivos_asbuilt;
    }

    const output = memoriais_descritivos_asbuilt.get({ plain: true });

    output.obra = await memoriais_descritivos_asbuilt.getObra({
      transaction,
    });

    output.clientes = await memoriais_descritivos_asbuilt.getClientes({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userClientes = (user && user.clientes?.id) || null;

    if (userClientes) {
      if (options?.currentUser?.clientesId) {
        where.clientesId = options.currentUser.clientesId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.obras,
        as: 'obra',

        where: filter.obra
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.obra
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  nome_obra: {
                    [Op.or]: filter.obra
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.clientes,
        as: 'clientes',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.titulo) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'memoriais_descritivos_asbuilt',
            'titulo',
            filter.titulo,
          ),
        };
      }

      if (filter.descricao) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'memoriais_descritivos_asbuilt',
            'descricao',
            filter.descricao,
          ),
        };
      }

      if (filter.arquivo_digital) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'memoriais_descritivos_asbuilt',
            'arquivo_digital',
            filter.arquivo_digital,
          ),
        };
      }

      if (filter.responsavel_tecnico) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'memoriais_descritivos_asbuilt',
            'responsavel_tecnico',
            filter.responsavel_tecnico,
          ),
        };
      }

      if (filter.comentarios_validacao) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'memoriais_descritivos_asbuilt',
            'comentarios_validacao',
            filter.comentarios_validacao,
          ),
        };
      }

      if (filter.data_entregaRange) {
        const [start, end] = filter.data_entregaRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            data_entrega: {
              ...where.data_entrega,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            data_entrega: {
              ...where.data_entrega,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.validado_por_copasa) {
        where = {
          ...where,
          validado_por_copasa: filter.validado_por_copasa,
        };
      }

      if (filter.clientes) {
        const listItems = filter.clientes.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          clientesId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.clientesId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } =
        await db.memoriais_descritivos_asbuilt.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('memoriais_descritivos_asbuilt', 'titulo', query),
        ],
      };
    }

    const records = await db.memoriais_descritivos_asbuilt.findAll({
      attributes: ['id', 'titulo'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['titulo', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.titulo,
    }));
  }
};
